<?php
/*
Plugin Name: Spoiler Button
Description: Adds "[spoiler]Spoiler Text[/spoiler]" Tags
Version: 1.6
Author: ePirat
Author URI: http://www.epirat.de/
*/

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile, 
	'Spoiler Button', 	
	'1.6', 		
	'ePirat',
	'http://www.epirat.de/', 
	'Adds [spoiler][/spoiler] (BBCode Style)',
	'plugins',
	'spoiler_settings_display'  
);

add_action('theme-header','code');
add_filter('content','spoiler_button_display');
add_action('plugins-sidebar','createSideMenu',array($thisfile,'Spoiler Settings'));
# functions
function spoiler_settings_display(){
    $errors = array();
    if (!empty($_POST)){
        if (!isset($_POST['dtype'])){
            $errors[] = "Please select a Display Type";
        }
        if (!isset($_POST['after'])){
            $after = false;
        } else {
            $after = true;
        }
        if ( (!isset($_POST['showtext'])) OR (empty($_POST['showtext'])) ){
            $errors[] = "Please enter a default show text.";
        }
        if (count($errors) == 0){
            $xml = new SimpleXMLElement('<settings></settings>');
            $xml->addChild('dtype', $_POST['dtype']);
            $xml->addChild('after', $after);
            $xml->addChild('showtext', $_POST['showtext']);
            $xml->addChild('hidetext', $_POST['hidetext']);
            if (!file_exists(GSDATAOTHERPATH."spoiler/")){
                mkdir(GSDATAOTHERPATH."spoiler/");  
            }
            $xml->asXML(GSDATAOTHERPATH."spoiler/settings.xml");
        }
        ?>
        <div class="updated">Settings Saved.</div>
        <?php
    }
        if (file_exists(GSDATAOTHERPATH."spoiler/settings.xml")){
            $xml = new SimpleXMLElement(GSDATAOTHERPATH."spoiler/settings.xml", 0, true);
        } else {
            
            $xml->dtype = "Button";
            $xml->after = false;
            $xml->showtext = "Show Spoiler";
            $xml->hidetext = "Hide Spoiler";
            
        }
        ?>
        <h2>Spoiler Plugin Settings</h2>
        <form method="post" action="">
        <h3>Display Type:</h3>
        <p>
        <input type="radio" name="dtype" value="Link" <?php if($xml->dtype == "Link"){ echo('checked="checked"'); } ?> /> Link<br />
        <input type="radio" name="dtype" value="Button" <?php if($xml->dtype == "Button"){ echo('checked="checked"'); } ?> /> Button<br />
        <input type="checkbox" name="after" value="true" <?php if($xml->after == True){ echo('checked="checked"'); } ?> /> Show Link/Button after spoiler</p>

        <h3>Default Text:</h3>
        <table>
        <tr>
        <td valign="middle">Show: </td>
        <td valign="middle"><input type="text" class="text short" name="showtext" value="<?php echo($xml->showtext); ?>" /></td>
        </tr>
        <tr>
        <td valign="middle">Hide: </td>
        <td valign="middle"><input type="text" class="text short" name="hidetext" value="<?php echo($xml->hidetext); ?>" /></td>
        </tr>
        </table>
        <input type="submit" value=" Save ">
        </form>
        <?php
}
function code(){
	global $content;
    if (file_exists(GSDATAOTHERPATH."spoiler/settings.xml")){
            $xml = new SimpleXMLElement(GSDATAOTHERPATH."spoiler/settings.xml", 0, true);
    } else {
        $xml->dtype = "Button";
        $xml->after = false;
        $xml->showtext = "Show Spoiler";
        $xml->hidetext = "Hide Spoiler";
    }
	if (preg_match('/\[spoiler(?:=([^]]+))?\](.*?)\[\/spoiler\]/s', $content)){
		?>
		<!-- JavaScripts -->

        <script type="text/javascript">
        /*
    Developed by Robert Nyman, http://www.robertnyman.com
    Code/licensing: http://code.google.com/p/getelementsbyclassname/
*/  
var getElementsByClassName = function (className, tag, elm){
    if (document.getElementsByClassName) {
        getElementsByClassName = function (className, tag, elm) {
            elm = elm || document;
            var elements = elm.getElementsByClassName(className),
                nodeName = (tag)? new RegExp("\\b" + tag + "\\b", "i") : null,
                returnElements = [],
                current;
            for(var i=0, il=elements.length; i<il; i+=1){
                current = elements[i];
                if(!nodeName || nodeName.test(current.nodeName)) {
                    returnElements.push(current);
                }
            }
            return returnElements;
        };
    }
    else if (document.evaluate) {
        getElementsByClassName = function (className, tag, elm) {
            tag = tag || "*";
            elm = elm || document;
            var classes = className.split(" "),
                classesToCheck = "",
                xhtmlNamespace = "http://www.w3.org/1999/xhtml",
                namespaceResolver = (document.documentElement.namespaceURI === xhtmlNamespace)? xhtmlNamespace : null,
                returnElements = [],
                elements,
                node;
            for(var j=0, jl=classes.length; j<jl; j+=1){
                classesToCheck += "[contains(concat(' ', @class, ' '), ' " + classes[j] + " ')]";
            }
            try {
                elements = document.evaluate(".//" + tag + classesToCheck, elm, namespaceResolver, 0, null);
            }
            catch (e) {
                elements = document.evaluate(".//" + tag + classesToCheck, elm, null, 0, null);
            }
            while ((node = elements.iterateNext())) {
                returnElements.push(node);
            }
            return returnElements;
        };
    }
    else {
        getElementsByClassName = function (className, tag, elm) {
            tag = tag || "*";
            elm = elm || document;
            var classes = className.split(" "),
                classesToCheck = [],
                elements = (tag === "*" && elm.all)? elm.all : elm.getElementsByTagName(tag),
                current,
                returnElements = [],
                match;
            for(var k=0, kl=classes.length; k<kl; k+=1){
                classesToCheck.push(new RegExp("(^|\\s)" + classes[k] + "(\\s|$)"));
            }
            for(var l=0, ll=elements.length; l<ll; l+=1){
                current = elements[l];
                match = false;
                for(var m=0, ml=classesToCheck.length; m<ml; m+=1){
                    match = classesToCheck[m].test(current.className);
                    if (!match) {
                        break;
                    }
                }
                if (match) {
                    returnElements.push(current);
                }
            }
            return returnElements;
        };
    }
    return getElementsByClassName(className, tag, elm);
};
            window.onload = function () {
                var spoilers = getElementsByClassName("spoiler");
                for (var i = spoilers.length - 1; i >= 0; i--) {
                    (function () {
                        var spoiler = spoilers[i];
                        spoiler.style.display = "none";
                        var name = getElementsByClassName("Spoilerbuttonname", "", spoiler);
                        switch (name.length) {
							case 0:
    							name = "<?php echo($xml->showtext) ?>";
    							nameh = "<?php echo($xml->hidetext) ?>";
    							break;
    						case 1:
    							name = name[0].innerHTML;
    							nameh = name;
    							break;
    						case 2:
    							var nameh = name[1].innerHTML;
    							name = name[0].innerHTML;
    							break;
						}
                        <?php if($xml->dtype == "Button"): ?>
                        var button = document.createElement("button");
                        <?php else: ?>
                        var button = document.createElement("a");
                        button.setAttribute("href","#");
                        <?php endif; ?>
                        button.innerHTML = name;
                        <?php if($xml->after == True): ?>
                        spoiler.parentNode.insertBefore(button, spoiler.nextSibling);
                        <?php else: ?>
                        spoiler.parentNode.insertBefore(button, spoiler);
                        <?php endif; ?>
                        try {
                        button.addEventListener("click", function (event) {
                            if (spoiler.style.display !== "none") {
                                spoiler.style.display = "none";
                                button.innerText = name;
                            } else {
                                spoiler.style.display = "block";
                                spoiler.style.backgroundColor = "transparent";
                                button.innerText = nameh;
                            }
							event.preventDefault();
                        }, false);
                        } catch (e) {
                            button.attachEvent("onclick", function (event) {
                                if (spoiler.style.display !== "none") {
                                    spoiler.style.display = "none";
                                    button.innerText = name;
                                } else {
                                    spoiler.style.display = "block";
                                    spoiler.style.backgroundColor = "transparent";
                                    button.innerText = nameh;
                                }
                                return false;
                            });
                        }
                        
                    }());
                }
            };
        </script>
		<style type="text/css">
		<!--
		div.spoiler:hover { background-color: transparent; }
		div.spoiler { background-color: #333; color: #333; }
		-->
		</style>
		<?php
	}
}

function spoiler_button_display($content)
{
		#This regex is from iszak (freenode #regex channel)
		$content = preg_replace_callback("/\[spoiler(?:=(.*?))?\](.*?)\[\/spoiler\]/s", "replika", $content);
		return $content;
}
function replika($cont) {
	$string = "<div class=\"spoiler\">";
	if (!empty($cont[1])){
		$split = explode("|||", $cont[1], 2);
		foreach ($split as $splitted){
			$string .= "<p class=\"Spoilerbuttonname\" style=\"display: none;\">".$splitted."</p>";
		}
	}
	$string .= "<p class=\"spoilertextcont\">".$cont[2]."</p></div>";
	return $string;
}
?>